;; SIZE.SCM
;; Calculate the size of an INTEX program. 
;; The size is the number of expression nodes in the abstract syntax tree.

(define program-size
  (lambda (pgm)
    (exp-size (program-body pgm))))

(define exp-size
  (lambda (exp)
    (cond ((literal? exp) 1)
          ((varref? exp) 1)
          ((binapp? exp)
           (+ 1
              (exp-size (binapp-rand1 exp))
              (exp-size (binapp-rand2 exp))))
          (else (error "EXP-SIZE: Unrecognized expression --" exp))
          )))
